package com.winhc.dataworks.flow.touch.configuration;

import com.winhc.dataworks.flow.touch.bean.DataWorksFlowJob;
import com.winhc.dataworks.flow.touch.bean.DataWorksFlowTask;
import com.winhc.dataworks.flow.touch.bean.NodeParam;
import org.yaml.snakeyaml.Yaml;

import java.io.File;
import java.io.FileReader;
import java.io.Reader;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/23 14:23
 * @Description:
 */
@SuppressWarnings("all")
public class SchemaInit {
    public static final List<DataWorksFlowJob> LIST;

    private static final String fileName = "task-xjk.yaml";

    static {
        Yaml yml = new Yaml();
        String path = Object.class.getResource("/").getPath().substring(1) + fileName;
        Reader reader = null;
        try {
            reader = new FileReader(new File(path));
        } catch (Exception e) {
            e.printStackTrace();
        }
        Map map = yml.loadAs(reader, Map.class);

        List jobs = ((List) map.get("job"));
        LIST = (List<DataWorksFlowJob>) jobs
                .stream()
                .map(m -> {
                    String project = ((String) ((Map<String, Object>) m).get("project"));
                    String flow = ((String) ((Map<String, Object>) m).get("flow"));
                    List<DataWorksFlowTask> collect1 = (List<DataWorksFlowTask>) ((List) ((Map<String, Object>) m).get("task"))
                            .stream()
                            .map(t -> {
                                String taskName = ((String) ((Map<String, Object>) t).get("taskName"));
                                List<Map<String, Object>> ll = ((List<Map<String, Object>>) ((Map<String, Object>) t).get("param"));
                                List<NodeParam> nodeParamList = ll.stream()
                                        .map(mm -> {
                                            String nodeId = String.valueOf(mm.remove("_nodeId"));
                                            Map<String, String> collect = mm.entrySet().stream().collect(Collectors.toMap(Map.Entry::getKey, e -> String.valueOf(e.getValue()), (o1, o2) -> o1));
                                            return NodeParam.builder().nodeId(nodeId).param(collect).build();
                                        }).collect(Collectors.toList());
                                return new DataWorksFlowTask(taskName, nodeParamList);
                            })
                            .collect(Collectors.toList());
                    DataWorksFlowJob build = DataWorksFlowJob.builder()
                            .project(project)
                            .flow(flow)
                            .task(collect1)
                            .build();
                    return build;
                })
                .collect(Collectors.toList());
    }
}
